# _MapNode\[K: ([Hashable](collections-Hashable) val & [Equatable](builtin-Equatable)\[K val\]), V: [Any](builtin-Any) #share\]

```pony
class val _MapNode[K: (Hashable val & Equatable[K val]), V: Any #share]
```

## Constructors

### empty

```pony
new val empty(
  l: U8 val)
: _MapNode[K val, V #share] val^
```
#### Parameters

*   l: [U8](builtin-U8) val

#### Returns

* [_MapNode](collections-persistent-_MapNode)\[K val, V #share\] val^

---

### create

```pony
new val create(
  es: Array[(_MapNode[K val, V #share] val | Array[(K val , V #share)] val | (K val , V #share))] iso,
  nm: U32 val,
  dm: U32 val,
  l: U8 val)
: _MapNode[K val, V #share] val^
```
#### Parameters

*   es: [Array](builtin-Array)\[([_MapNode](collections-persistent-_MapNode)\[K val, V #share\] val | [Array](builtin-Array)\[(K val , V #share)\] val | (K val , V #share))\] iso
*   nm: [U32](builtin-U32) val
*   dm: [U32](builtin-U32) val
*   l: [U8](builtin-U8) val

#### Returns

* [_MapNode](collections-persistent-_MapNode)\[K val, V #share\] val^

---

## Public Functions

### apply

```pony
fun val apply(
  hash: U32 val,
  key: K val)
: V #share ?
```
#### Parameters

*   hash: [U32](builtin-U32) val
*   key: K val

#### Returns

* V #share ?

---

### update

```pony
fun val update(
  hash: U32 val,
  leaf: (K val , V #share))
: (_MapNode[K val, V #share] val , Bool val) ?
```
#### Parameters

*   hash: [U32](builtin-U32) val
*   leaf: (K val , V #share)

#### Returns

* ([_MapNode](collections-persistent-_MapNode)\[K val, V #share\] val , [Bool](builtin-Bool) val) ?

---

### remove

```pony
fun val remove(
  hash: U32 val,
  key: K val)
: _MapNode[K val, V #share] val ?
```
#### Parameters

*   hash: [U32](builtin-U32) val
*   key: K val

#### Returns

* [_MapNode](collections-persistent-_MapNode)\[K val, V #share\] val ?

---

### entries

```pony
fun box entries()
: Array[(_MapNode[K val, V #share] val | Array[(K val , V #share)] val | (K val , V #share))] val
```

#### Returns

* [Array](builtin-Array)\[([_MapNode](collections-persistent-_MapNode)\[K val, V #share\] val | [Array](builtin-Array)\[(K val , V #share)\] val | (K val , V #share))\] val

---

## Private Functions

### _set_bit

```pony
fun box _set_bit(
  bm: U32 val,
  i: U32 val)
: U32 val
```
#### Parameters

*   bm: [U32](builtin-U32) val
*   i: [U32](builtin-U32) val

#### Returns

* [U32](builtin-U32) val

---

### _clear_bit

```pony
fun box _clear_bit(
  bm: U32 val,
  i: U32 val)
: U32 val
```
#### Parameters

*   bm: [U32](builtin-U32) val
*   i: [U32](builtin-U32) val

#### Returns

* [U32](builtin-U32) val

---

### _has_bit

```pony
fun box _has_bit(
  bm: U32 val,
  i: U32 val)
: Bool val
```
#### Parameters

*   bm: [U32](builtin-U32) val
*   i: [U32](builtin-U32) val

#### Returns

* [Bool](builtin-Bool) val

---

### _mask

```pony
fun box _mask(
  hash: U32 val,
  l: U8 val)
: U32 val
```
#### Parameters

*   hash: [U32](builtin-U32) val
*   l: [U8](builtin-U8) val

#### Returns

* [U32](builtin-U32) val

---

### _array_index

```pony
fun box _array_index(
  nm: U32 val,
  dm: U32 val,
  idx: U32 val)
: U32 val
```
#### Parameters

*   nm: [U32](builtin-U32) val
*   dm: [U32](builtin-U32) val
*   idx: [U32](builtin-U32) val

#### Returns

* [U32](builtin-U32) val

---

